"""Update token column type

Revision ID: 42a14d6143f1
Revises: b9a2d6d0a2c7
Create Date: 2024-04-12 15:19:52.639580

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = '42a14d6143f1'
down_revision = 'b9a2d6d0a2c7'
branch_labels = None
depends_on = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table('oauth2_access_token', schema=None) as batch_op:
        batch_op.alter_column(
            'token',
            existing_type=sa.String(length=255),
            type_=sa.Text(),
            existing_nullable=True,
        )
        batch_op.alter_column(
            'refresh_token',
            existing_type=sa.String(length=255),
            type_=sa.Text(),
            existing_nullable=True,
        )

    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table('oauth2_access_token', schema=None) as batch_op:
        batch_op.alter_column(
            'token',
            existing_type=sa.Text(),
            type_=sa.String(length=255),
            existing_nullable=True,
        )
        batch_op.alter_column(
            'refresh_token',
            existing_type=sa.String(length=255),
            type_=sa.Text(),
            existing_nullable=True,
        )

    # ### end Alembic commands ###
